package com.bwie.goods.controller;

import com.alibaba.fastjson.JSONObject;
import com.bwie.common.domain.request.GoodsRequest;
import com.bwie.common.result.Result;
import com.bwie.goods.service.GoodsService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

@RestController
@Log4j2
public class GoodsController {
    @Autowired
    private GoodsService goodsService;

    @Autowired
    private HttpServletRequest request;

    @GetMapping("typeshow")
    public Result typeshow(){
        log.info("功能名称:xxx,请求URI:{},请求方式:{}",
                request.getRequestURI(),request.getMethod());
        Result result = goodsService.typeshow();
        log.info("功能名称:xxx,请求URI:{},请求方式:{},响应结果:{}",
                request.getRequestURI(),request.getMethod(), JSONObject.toJSONString(result));
        return result;
    }

    @PostMapping("show")
    public Result show(@RequestBody GoodsRequest goodsRequest){
        log.info("功能名称:xxx,请求URI:{},请求方式:{},请求参数:{}",
                request.getRequestURI(),request.getMethod(),goodsRequest);
        Result result = goodsService.show(goodsRequest);
        log.info("功能名称:xxx,请求URI:{},请求方式:{},响应结果:{}",
                request.getRequestURI(),request.getMethod(), JSONObject.toJSONString(result));
        return result;
    }


}
