package com.bwie.goods.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.bwie.common.constants.TokenConstants;
import com.bwie.common.domain.Goods;
import com.bwie.common.domain.Opp;
import com.bwie.common.domain.SysUser;
import com.bwie.common.domain.Type;
import com.bwie.common.domain.request.GoodsRequest;
import com.bwie.common.result.PageResult;
import com.bwie.common.result.Result;
import com.bwie.common.utils.JwtUtils;
import com.bwie.goods.feign.GoodsFeign;
import com.bwie.goods.mapper.GoodsMapper;
import com.bwie.goods.service.GoodsService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

@Service
public class GoodsServiceImpl implements GoodsService {
    @Autowired
    private StringRedisTemplate redisTemplate;

    @Autowired
    private HttpServletRequest request;

    @Autowired
    private GoodsMapper goodsMapper;

    @Autowired
    private GoodsFeign goodsFeign;

    @Override
    public Result typeshow() {
        if(!redisTemplate.hasKey("types")){
            List<Type> typelist = goodsMapper.typelist();
            for (Type type : typelist) {
                redisTemplate.opsForSet().add("list", JSONObject.toJSONString(type));
            }
        }

        Set<String> list = redisTemplate.opsForSet().members("list");
        ArrayList<Type> types = new ArrayList<>();
        for (String s : list) {
            Type type = JSONObject.parseObject(s, Type.class);
            types.add(type);
        }

        return Result.success(types);
    }

    @Override
    public Result show(GoodsRequest goodsRequest) {

        Result<Opp> finduser = goodsFeign.finduser();
        Opp data = finduser.getData();
        if(null==data){
            goodsMapper.addopp(getInfo().getUserId());
        }
        PageHelper.startPage(goodsRequest.getPageNum(),goodsRequest.getPageSize());
        List<Goods> show = goodsMapper.show(goodsRequest);
        PageInfo<Goods> goodsPageInfo = new PageInfo<>(show);
        return PageResult.toResult(goodsPageInfo.getTotal(),show);
    }

    public SysUser getInfo() {
        String header = request.getHeader(TokenConstants.TOKEN);
        String userKey = JwtUtils.getUserKey(header);
        String s = redisTemplate.opsForValue().get(TokenConstants.LOGIN_TOKEN_KEY + userKey);
        return JSONObject.parseObject(s, SysUser.class);
    }


}
