package com.bwie.opp.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.bwie.common.constants.TokenConstants;
import com.bwie.common.domain.Opp;
import com.bwie.common.domain.SysUser;
import com.bwie.common.result.Result;
import com.bwie.common.utils.JwtUtils;
import com.bwie.opp.mapper.OppMapper;
import com.bwie.opp.service.OppService;
import com.bwie.opp.util.MsgUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;

@Service
public class OppServiceImpl implements OppService {

    @Autowired
    private MsgUtil msgUtil;

    @Autowired
    private OppMapper oppMapper;

    @Autowired
    private HttpServletRequest request;;

    @Autowired
    private StringRedisTemplate redisTemplate;

    @Override
    public Result<Opp> finduser() {
        String s = redisTemplate.opsForValue().get("present:");
        Integer i = JSONObject.parseObject(s, Integer.class);
        Opp findopp = oppMapper.findopp(i);
        return Result.success(findopp);
    }

    @Override
    public Result yue() {
        //修改余额
        if(getInfo().getUserMoney()<30){
            return Result.error("余额不足");
        }
        oppMapper.updmoney(getInfo().getUserId());
        //修改opp状态
        oppMapper.updyue(getInfo().getUserId());
        return Result.success("预约成功");
    }

    @Override
    public Result tui() {
        oppMapper.tuimoney(getInfo().getUserId());
        oppMapper.updtui(getInfo().getUserId());
        msgUtil.sendMsg(getInfo().getUserPhone(),"111");
        return Result.success("已退票");
    }

    @Override
    public Result dui() {
        oppMapper.upddui(getInfo().getUserId());
        return Result.success("已兑换");
    }

    public SysUser getInfo() {
        String header = request.getHeader(TokenConstants.TOKEN);
        String userKey = JwtUtils.getUserKey(header);
        String s = redisTemplate.opsForValue().get(TokenConstants.LOGIN_TOKEN_KEY+userKey);
        return JSONObject.parseObject(s, SysUser.class);
    }
}
